function [centers, P] = constrwheel(k,d)
%k=9;  % number of sets/spokes
%n=k;  % number of spokes in each set
% d is embedding dim.
addpath('mySphere')
% construct wheel/wheels example - input k needs to be defined
% embedding dim is d = 2 or 3
if d > 3
	fprintf('ERROR: d > 3 in constwheel; reset to 3 for wheel example\n')
	d = 3;
end
rbig = 1; %radius of big wheel
if d == 2
      thetaa = 2*pi/k;
      thetas = (0:thetaa:2*pi)';  % col vector
      thetas = thetas(1:end-1); % last point duplicated
      mindist = min(min(.75,norm([cos(thetaa) sin(thetaa)])), ...
      	     norm(rbig*[cos(thetaa) sin(thetaa)]-[rbig 0]));
      rsmall = mindist/4; %radius of small wheels
      centers = [cos(thetas) sin(thetas)];  % centers of sets
              %Construct EDM by data P
      %P = [];
      %for ii = 1:k   % adding a random translation to each random set
      %	P = [P ; centers(ii,:) + mindist*centers];
      %end
      P = kron(centers,ones(k,1)) + mindist*kron(ones(k,1),centers);
      %norm(P-P2)
else
      [X,Y,Z,N_new] = mySphere(k-1);
      mindist = .1;
      centers = [X' Y' Z'];
      P = kron(centers,ones(k,1)) + mindist*kron(ones(k,1),centers);
      figure(2)
      clf
      plot3(X,Y,Z,'b-x')
      title('large ball with x as centers for small balls')
      hold on
      plot3(P(:,1),P(:,2),P(:,3),'ko')
      hold off
end
